#!/usr/bin/env python
# encoding=utf-8
#
# Networking
# (c) Mihai Maruseac

import sys, os, time
import socket
import select
import pickle
import gtk
from threading import Thread

HOST = '10.38.23.154'#'0.0.0.0'#'192.168.1.255'		# use it for UDP broadcasting
SERVER = '10.38.23.154'#'127.0.0.1'#'192.168.1.2'	# tcp connection server
SERVER_PORT = 5307		# tcp connection server port
PORT = 53072			# jeopa
BUFFER_SIZE = 100
TIMEOUT = 1

''' Administreaza o conexiune tcp.
	Conexiunea trebuie sa stea activa
	TODO: handle disconnect
'''

class Connector(Thread):
    def init(self, window):
        self.window = window
        try:
            self.tcps = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            self.tcps.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
            self.tcps.bind(("0.0.0.0", SERVER_PORT))
            self.tcps.listen(1)
        except socket.error, msg:
            print "Eroare la conectare: ", msg
            sys.exit(-1)
        self.socks = [self.tcps, sys.stdin]
        self.ready = True
        self.users = {}

    def run(self):
        while self.ready:
            rtr, rtw, ie = select.select(self.socks, [], [])

            for s in rtr:
                if s == self.tcps:
                    ' conexiune noua '
                    cli_sock, cli_addr = self.tcps.accept()
                    self.socks.append(cli_sock)
                    uname = cli_sock.recv(1024)
                    parts = uname.split(":")
                    if self.window.started or len(parts) != 2 or parts[1] in self.users:
                        cli_sock.send("l:n:-1")
                    else:
                        uname = parts[1]
                        self.users[uname] = cli_sock
                        self.window.users[uname] = (0, len(self.users))
                        #cli_sock.send("l:y:%d" % len(self.users))
                        cli_sock.send("l:y:%d:%s" % (len(self.users), pickle.dumps(self.window.questions)))
                        self.window.update_users()
                elif s == sys.stdin:
                    pass
                else:
                    data = s.recv(1024)
                    if data:
                        print data
                        if data[0] == 'b':
                            for user in self.users:
                                if self.users[user] == s and self.window.once == True:
                                    self.window.send_freeze(user)
                    else:
                        print "User disconnected"
                        s.close()
                        self.socks.remove(s)
                        for k in self.users.keys():
                            if self.users[k] == s:
                                self.users.pop(k)
                                self.window.users.pop(k)
                        self.window.update_users()

    def stop_con(self):
        self.ready = False
        for s in self.socks:
            s.close()
        self.tcps.close()

    def ban(self, username):
        if username in self.users.keys():
            self.users.pop(username)
            self.window.users.pop(username)
            self.window.update_users()
        else:
            print "Utilizatorul %s nu era logat" % username

    def init_udp(self):
        self.udps = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        self.udps.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
	self.udps.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)

    def broadcast_udp_msg(self, msg):
        print msg
        self.udps.sendto(msg, ('255.255.255.255', PORT))

    def close_udp(self):
        self.udps.close()
