#!/usr/bin/env python
# coding=utf-8
# 
#	Fereastra principala/login program jeopardy
# (c) Mihai Maruseac

import sys, os.path
import network
import gtk
import time
import io

class MMButton(gtk.Button):
    def __init__(self, str, i, j):
        super(MMButton, self).__init__(str)
        self.i = i;
        self.j = j;

class MainWindow:
    def __init__(self):
        self.started = False
        self.users = {}
        ' initializez interfata din xml '
        builder = gtk.Builder()
        builder.add_from_file(os.path.dirname(__file__) + '/server.glade')
        self.window = builder.get_object('window1')
        self.userListLabel = builder.get_object('label4')
        self.startBtn = builder.get_object('button1')
        self.banBtn = builder.get_object('button2')
        builder.connect_signals(self)
        ' salvez builder pentru viitoare folosiri'
        self.builder = builder
        ' detalii suplimentare care nu sunt in xml '

        f = open(os.path.dirname(__file__) + "/intrebari", "r")
        line = f.readline()
        self.num_l = int(line)
        line = f.readline()
        self.num_s = int(line)
        self.questions = [[ "" for j in range(self.num_s)] for i in\
                range(self.num_l)]
        for i in range(self.num_l):
            for j in range(self.num_s):
                line = f.readline()
                line = line.split(':')[2]
                self.questions[i][j] = line

        self.qasked = 0
        self.qav = self.num_l * self.num_s

        g = open(os.path.dirname(__file__) + "/rasp", "r")
        self.answers = [[ "" for j in range(self.num_s)] for i in\
                range(self.num_l)]
        for i in range(self.num_l):
            for j in range(self.num_s):
                line = g.readline()
                line = line.split(':')[2]
                self.answers[i][j] = line

        self.align2 = builder.get_object('alignment2')

        fixed = gtk.Table(self.num_s, self.num_l, True)

        ' build a button matrix '
        self.buttons = [[ MMButton('%c%d'%(chr(ord('A')+i), j), j, i) for j in\
                range(self.num_s)] for i in range(self.num_l)]

        ' displaying it and setting some actions '
        for i in range(self.num_l):
            for j in range(self.num_s):
                fixed.attach(self.buttons[i][j], i, i+1, j, j+1)
                self.buttons[i][j].set_sensitive(False)
                self.buttons[i][j].connect('clicked', self.q_select)

        self.align2.add(fixed)
        ' incarc fereastra '
        self.window.show()
        self.window.show_all()
        'alte detalii'
        self.con = network.Connector()
        self.con.init(self)
        self.con.start()
        self.con.init_udp()
        self.waiting_answer = False

    def on_mw_destroy(self, widget, data=None):
        gtk.main_quit()
        self.con.stop_con()
        self.con.close_udp()
        sys.exit(0)

    def on_aboutmenu_activate(self, event):
        ad = gtk.AboutDialog()
        ad.set_name("Jeopardy Server")
        ad.set_authors(["Mihai Maruseac <mihai.maruseac@gmail.com>"])
        ad.set_comments("Server pentru Jeopardy\nlistening on: %d" % network.SERVER_PORT)
        ad.set_version('0.2')
        ad.set_website('http://elf.cs.pub.ro/uso/jeopardy/')
        ad.run()
        ad.destroy()

    def set_statusbar(self, text):
        sb = self.builder.get_object("statuslabel")
        sb.set_text(str(text))

    def on_ban(self, widget, data=None):
        self.bw = self.builder.get_object('banwindow')
        self.bw.set_modal(True)
        self.bw.show()

    def on_reset(self, widget, data=None):
        self.once = True
        self.started = False
        self.banBtn.set_sensitive(True)
        self.startBtn.set_sensitive(False)
        for i in range(self.num_l):
            for j in range(self.num_s):
                self.buttons[i][j].set_sensitive(False)
        self.users = {}
        self.con.users = {}
        self.waiting_answer = False
        self.update_users()

    def on_start(self, widget, data=None):
        self.once = True
        self.started = True
        self.banBtn.set_sensitive(False)
        self.startBtn.set_sensitive(False)
        for i in range(self.num_l):
            for j in range(self.num_s):
                self.buttons[i][j].set_sensitive(True)
        msg = "s:%d:%d:%d:" % (self.num_l, self.num_s, len(self.users))
        for user in self.users:
            t = self.users[user]
            msg += "%d,%s "  % (t[1], user)
        self.con.broadcast_udp_msg(msg)

    def sendq(self, i, j):
        msg = "q:%d:%d:%d:" % (i, j, len(self.users))
        for user in self.users:
            t = self.users[user]
            msg += "%d,%d " % (t[1], t[0])
        msg += ": %s" % (self.questions[j][i])
        self.builder.get_object('questiontext').set_text(self.questions[j][i])
        self.tehanswer = self.answers[j][i]
        self.con.broadcast_udp_msg(msg)
        self.once = True

    def send_freeze(self, who_got_the_answer):
        self.once = False
        self.con.broadcast_udp_msg('f')
        builder = gtk.Builder()
        builder.add_from_file(os.path.dirname(__file__) + '/server.glade')
        self.jw = builder.get_object('judge')
        self.username_label = builder.get_object('username')
        builder.get_object('answerlabel').set_text(self.tehanswer)
        builder.connect_signals(self)
        self.username_label.set_text(who_got_the_answer)
        self.jw.set_modal(True)
        self.jw.show()

    def send_arbitrary_freeze(self, widget, data=None):
        self.con.broadcast_udp_msg('f')

    def send_arbitrary_die(self, widget, data=None):
        self.con.broadcast_udp_msg('d')

    def on_apocalypse(self, widget, data=None):
        self.con.broadcast_udp_msg('a')
        self.on_reset(None, None)

    def update_users(self):
        text = ""
        for k in self.users:
            text += "%s\t\t%d\n" % (k, self.users[k][0])
        self.userListLabel.set_text(text)
        if self.started:
            return
        if len(self.users) > 0:
            self.startBtn.set_sensitive(True)
            self.banBtn.set_sensitive(True)
        else:
            self.startBtn.set_sensitive(False)
            self.banBtn.set_sensitive(False)

    def on_ban_do(self, widget, data=None):
        username = self.builder.get_object('nameentry').get_text()
        self.builder.get_object('nameentry').set_text('')
        self.con.ban(username)
        self.bw.hide()

    def q_select(self, widget):
        print "A", widget.i, widget.j
        widget.set_sensitive(False)
        self.qasked += 1
        if self.qasked == self.qav:
            print "Gata"
        self.sendq(widget.i, widget.j)
        self.waiting_answer = True
        self.score = 100 * widget.i + 100

    def q_b(self, widget):
        username = self.username_label.get_text()
        self.users[username] = (self.users[username][0] - self.score,
                self.users[username][1])
        self.update_users()
        self.jw.hide()

    def q_g(self, widget):
        username = self.username_label.get_text()
        self.users[username] = (self.users[username][0] + self.score,
                self.users[username][1])
        self.update_users()
        self.jw.hide()


def main():
    ' Parametrii, primul port '
    if len(sys.argv) > 1:
        network.SERVER_PORT = int(sys.argv[1])

    w = MainWindow()
    gtk.gdk.threads_init()
    gtk.gdk.threads_enter()
    gtk.main()
    gtk.gdk.threads_leave()

# Daca este pornit din linie de comanda:
if __name__ == "__main__":
    main()	
